/**
  * @file st756xx.c
  * @author generated by mrt-device utility 
  * @link [https://mrt.readthedocs.io/en/latest/pages/mrtutils/mrt-device.html]
  * @brief Device driver for st756xx device
  *
  */


/* Includes ------------------------------------------------------------------*/
#include "st756xx.h"
#include "st756xx_cmd.h"

/*user-block-top-start*/
/* Private Variables ---------------------------------------------------------*/
/* Private Functions ---------------------------------------------------------*/
/*user-block-top-end*/


typedef mrt_status_t (*f_gfx_write)(struct gfx_struct* gfx, int x, int y, uint8_t* data, int len, bool wrap); //pointer to write function


mrt_status_t st756xx_init_hw(st756xx_t* dev, mrt_spi_handle_t spi, mrt_gpio_t chipSelect, mrt_gpio_t cmdData)
{
    mrt_status_t status;

    dev->mSpiHandle = spi;
    dev->mChipSelect = chipSelect;
    dev->mCmdData = cmdData;

    st756_write_cmd(dev, ST756XX_CMD_RESET);
    st756_write_cmd(dev, ST756XX_CMD_START_LINE(0));
    st756_write_cmd(dev, ST756XX_CMD_SEG_DIR(0));
    st756_write_cmd(dev, ST756XX_CMD_DISP_ON);

    return status;
}

mrt_status_t st756xx_init_canvas(st756xx_t* dev, int width, int height)
{
    mrt_status_t status = MRT_STATUS_OK;

    status = gfx_init_buffered(&dev->mCanvas, width, height, GFX_COLOR_MODE_MONO);

    return status;
}


mrt_status_t st756xx_write_cmd(st756xx_t* dev, uint8_t cmd)
{

    uint8_t returnData;
    MRT_GPIO_WRITE(dev->mCmdData, 0);
    MRT_GPIO_WRITE(dev->mChipSelect, 0);

    MRT_SPI_TRANSFER(dev->mSpiHandle, &cmd, &returnData, 1, 1000);

    MRT_GPIO_WRITE(dev->mChipSelect, 1);
    MRT_GPIO_WRITE(dev->mCmdData, 1);
}

mrt_status_t st756xx_write_data(st756xx_t* dev, uint8_t* data, int len)
{
    uint8_t returnData;
    MRT_GPIO_WRITE(dev->mCmdData, 1);
    MRT_GPIO_WRITE(dev->mChipSelect, 0);

    MRT_SPI_TRANSFER(dev->mSpiHandle, data, &returnData, len, 1000);

    MRT_GPIO_WRITE(dev->mChipSelect, 1);
    MRT_GPIO_WRITE(dev->mCmdData, 1);
}

mrt_status_t st756xx_gfx_refresh(st756xx_t* dev)
{
    mrt_status_t status = MRT_STATUS_OK;
    //Set x and y to 0
    status |= st756xx_write_cmd(gfx->mDevice, ST756XX_CMD_PAGE_ADDR(0));
    status |= st756xx_write_cmd(gfx->mDevice, ST756XX_CMD_COL_ADDR_MSB(0));
    status |= st756xx_write_cmd(gfx->mDevice, ST756XX_CMD_COL_ADDR_LSB(0));

    //Write data
    status |= st756xx_write_data(dev, dev->mCanvas.mBuffer, dev->mCanvas.mBufferSize);


    return MRT_STATUS_OK;
}
